/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *  
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *  
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */


#ifndef _NMM_YUVDEINTERLACENODE_HPP_
#define _NMM_YUVDEINTERLACENODE_HPP_ _NMM_YUVDEINTERLACENODE_HPP_

#include "nmm/nmm_prefix.hpp"

#include "nmm/multimedia/GenericFilterNode.hpp"
#include "visibility_YUVDeinterlaceNode.hpp"
namespace NMM {
  
  class DLLEXPORT YUVDeInterlaceNode
    : public GenericFilterNode
  {
  private:
    int width;
    int height;
    Result resize(nmm_int32&, nmm_int32&);
    
    Result doInit();
    Result doDeinit();
    Result doInitOutput();
    
    static void yuv_deinterlace(char *, int, int);
    static inline void rgb_average(char*, char*, char*, int);
    
    Result setupOutputFormat(const Format* in_f);
    
  protected:
    Message* processBuffer(Buffer*);
    
    Result setFormat(const Format& format);
    
  public:
    YUVDeInterlaceNode(const char *name = "YUVDeInterlaceNode",
		       const StreamQueue::Mode queue_mode = StreamQueue::MODE_SUSPEND, 
		       const int queue_size = 1 );
    ~YUVDeInterlaceNode();
  };

}

#include "nmm/nmm_suffix.hpp"

#endif // _NMM_YUVDEINTERLACENODE_HPP_
